
#include 'Dll.ch'
#include 'WinDefs.ch'
#define  CRLF         (Chr(13) + Chr(10))
PROCEDURE Main()
LOCAL  cMens
ConfirmBox(NIL, 'Starting the execution')

ApicreateProcess_(NIL,;
                  'Notepad.exe',;
                  NIL,;
                  .t.,;
                  @cMens)
if !Empty(cMens)
   ConfirmBox(NIL, ('Encountered the problem:' + CRLF +;
                    cMens))
else
   ConfirmBox(NIL, 'Finished the execution')
endif
QUIT
RETURN

PROCEDURE AppSys()
Set(_SET_CHARSET, CHARSET_ANSI)
RETURn

PROCEDURE DbeSys()
RETURN


 ////////////
 //
FUNCTION  ApiCreateProcess_(cApplication, cCommandLine, cTargetDir, lRunAsynch, cMens)
 //       Executa um processo(ou programa) onde:
 //               [<cApplication>]        -> program name
 //               [<cCommandLine>]        -> command line to be executed
 //                                          if <cApplication> is informed <cCommandLine> can to be NIL
 //               [<cTargetDir>]          -> Path where the process will to be executed. It cam to be a UNC path
 //                                          Default to Curdir()
 //               [<lRunAsynch>]          -> wait for the launched process to complete its execution?
 //                                          Default: .t.
 //                                          if .t. the function WaitForSingleObject() will to be executed until it finishes
 //                                             It is used the structure PROCES_INFORMATION and the function
 //                                             CloseHandle() para fechar os handles.
 //               [@<cMens>]              -> string for to contain the error message
 //
 //       More details:
 //                         https://msdn.microsoft.com/en-us/library/windows/desktop/ms682425(v=vs.85).aspx
 //                         https://msdn.microsoft.com/pt-br/library/windows/desktop/ms687032(v=vs.85).aspx
 //                         https://msdn.microsoft.com/en-us/library/windows/desktop/ms724211(v=vs.85).aspx
 //       Example in:       https://msdn.microsoft.com/en-us/library/windows/desktop/ms682512(v=vs.85).aspx
 //
 //       Xbase++:
 //                        if !ApicreateProcess_(NIL,;
 //                           'Notepad.exe',;
 //                           NIL,;
 //                           .t.,;
 //                           @cMens)
 //       Retorna .t. ok
 //               .f. failed
 /////
STATIC  cCreate, cWait,        cClose
LOCAL   nHandle, sStartupInfo, sProcessInfo, hProcess,lOk

if cCreate == NIL
   nHandle := ApiLoadDll_('Kernel32.dll')
   cCreate := DllPrepareCall(nHandle, DLL_STDCALL, 'CreateProcessA')
   cWait   := DllPrepareCall(nHandle, DLL_STDCALL, 'WaitForSingleObject')
   cClose  := DllPrepareCall(nHandle, DLL_STDCALL, 'CloseHandle')
endif
sStartupInfo := (U2Bin(18 * 4) + Replicate(Chr(0), (17 * 4))) // typedef struct _STARTUPINFO {DWORD  cb;              01
                                                              //                              LPTSTR lpReserved;      02
                                                              //                              LPTSTR lpDesktop;       03
                                                              //                              LPTSTR lpTitle;         04
                                                              //                              DWORD  dwX;             05
                                                              //                              DWORD  dwY;             06
                                                              //                              DWORD  dwXSize;         07
                                                              //                              DWORD  dwYSize;         08
                                                              //                              DWORD  dwXCountChars;   09
                                                              //                              DWORD  dwYCountChars;   10
                                                              //                              DWORD  dwFillAttribute; 11
                                                              //                              DWORD  dwFlags;         12
                                                              //                              WORD   wShowWindow;     13
                                                              //                              WORD   cbReserved2;     14
                                                              //                              LPBYTE lpReserved2;     15
                                                              //                              HANDLE hStdInput;       16
                                                              //                              HANDLE hStdOutput;      17
                                                              //                              HANDLE hStdError;       18
                                                              //                             } STARTUPINFO, *LPSTARTUP0INFO;

sProcessInfo := Replicate(U2Bin(0), 4)                        // typedef struct _PROCESS_INFORMATION {
                                                              //  HANDLE hProcess;
                                                              //  HANDLE hThread;
                                                              //  DWORD  dwProcessId;
                                                              //  DWORD  dwThreadId;
                                                              //  } PROCESS_INFORMATION, *LPPROCESS_INFORMATION;
                                                              //    Members
                                                              //    hProcess    -> A handle to the newly created process.
                                                              //                   The handle is used to specify the
                                                              //                   process in all functions that perform operations
                                                              //                   on the process object.
                                                              //    hThread     -> A handle to the primary thread of the newly
                                                              //                   created process. The handle is used to specify
                                                              //                   the thread in all functions that perform operations
                                                              //                   on the thread object.
                                                              //    dwProcessId -> A value that can be used to identify a process.
                                                              //                   The value is valid from the time the process is
                                                              //                   created until all handles to the process are
                                                              //                   closed and the process object is freed;
                                                              //                   at this point, the identifier may be reused.
                                                              //    dwThreadId  -> A value that can be used to identify a thread.
                                                              //                   The value is valid from the time the thread is
                                                              //                   created until all handles to the thread are closed
                                                              //                   and the thread object is freed; at this point,
                                                              //                   the identifier may be reused.
if     DllExecuteCall(cCreate,;
                      cApplication,;                          //CreateProcessA(_In_opt_    LPCTSTR                lpApplicationName,
                      cCommandLine,;                          //               _Inout_opt_ LPTSTR                 lpCommandLine,
                      NIL,;                                   //               _In_opt_    LPSECURITY_ATTRIBUTES  lpProcessAttributes,
                      NIL,;                                   //               _In_opt_    LPSECURITY_ATTRIBUTES  lpThreadAttributes,
                      0,;    // FALSE                         //               _In_        BOOL                   bInheritHandles,
                      0,;                                     //               _In_        DWORD                  dwCreationFlags,
                      NIL,;                                   //               _In_opt_    LPVOID                lpEnvironment,
                      cTargetDir,;                            //               _In_opt_    LPCTSTR                lpCurrentDirectory,
                      @sStartupInfo,;                         //               _In_        LPSTARTUPINFO          lpStartupInfo,
                      @sProcessInfo) == 0                     //               _Out_       LPPROCESS_INFORMATION) lpProcessInformation
       lOk   := .f.                                           //
       cMens := ApiGetLasterror_()                            //
else
   hProcess      := Bin2U(Left(sProcessInfo, 4))
   if lRunAsynch == NIL .or.;
       lRunAsynch
       DllExecuteCall(cWait, hProcess, INFINITE)
       cMens := ApiGetLasterror_()
       lOk   := Empty(cMens)
   else
      lOk   := .t.
      cMens := ''
   endif
   if lOk
      DllExecuteCall(cClose, hProcess)
      DllExecuteCall(cClose, Bin2u(SubStr(sProcessInfo, 5, 4)))
   endif
endif
RETURN lOk


 ////////////
 //
FUNCTION ApiLoadDll_(cDll)
 //      Carrega a Dll, onde:
 //               <cDll> -> Nome da Dll a ser carregada. Se no tiver
 //                         extenso ela ser includa
 //      Retorna o handle da Dll ou 0 se ela nao pode ser carregada
 //
 /////
STATIC aDllLoaded := {}                  // Dlls carregadas: {{cDllName, nDllHandle}, ...}
LOCAL  nDllHandle

cDll := Lower(AllTrim(cDll))
if Right(cDll, 4) <> '.dll'
   cDll           += '.dll'
endif

nDllHandle    := AScan(aDllLoaded, {|x| x[01] == cDll})
if nDllHandle  > 0
   nDllHandle := aDllLoaded[nDllHandle, 02]
else
   nDllHandle := DllLoad(cDll)
   AAdd(aDllLoaded, {cDll, nDllHandle})
endif
RETURN nDllHandle

 ////////////
 //
FUNCTION ApiGetLastError_(nTipError)
 //      Obtm a mensagem de erro decorrente da execuo de funes executadas por DllExecuteCall() ou
 //            equivalente, onde:
 //      [<nTipError>] -> "Dica" (Tip) contendo um nmero de erro compatvel com o DosError() para
 //                       ser usado como retorno da mensagem quando a execuo da API falha
 //                       e no se obtm nenhuma informao de erro retornado pela funo.
 //                       Exemplo:
 //                               ic    := InternetConnectA(......)
 //                               if ic == 0
 //                                  ApiGetLasterror_(8466 )   // "Tip" -> ERROR_DS_DRA_EXTN_CONNECTION_FAILED
 //                               endif
 //
 //      Retorna: a mensagem correspondente ao erro sem CRLF no final ou ''
 /////
STATIC  cErrorInternet, cGetLast, cFormatError
LOCAL   nHandle, nLastErr, nExtErr, nLen, cMessage

if cGetLast       == NIL
   nHandle        := ApiLoadDll_('WinInet.dll')
   cErrorInternet := DllPrepareCall(nHandle, DLL_STDCALL, 'InternetGetLastResponseInfoA')
   nHandle        := ApiLoadDll_('Kernel32.dll')
   cGetLast       := DllPrepareCall(nHandle, DLL_STDCALL, 'GetLastError')
   cFormatError   := DllPrepareCall(nHandle, DLL_STDCALL, 'FormatMessageA')
   //                                                      DWORD WINAPI FormatMessage(_In_      DWORD dwFlags,
   //                                                                                 _In_opt_  LPCVOID lpSource,
   //                                                                                 _In_      DWORD dwMessageId,
   //                                                                                 _In_      DWORD dwLanguageId,
   //                                                                                 _Out_     LPTSTR lpBuffer,
   //                                                                                 _In_      DWORD nSize,
   //                                                                                 _In_opt_  va_list *Arguments)
endif

cMessage       := ''
nLastErr       := DllExecuteCall(cGetLast)
if nLastErr    == NO_ERROR
   nLastErr    := DOSError()
   if nLastErr == NO_ERROR
      nLastErr := FError()
   endif
endif
do while nLastErr <> NO_ERROR
                  //
                  //    Erro retornado por GetLastError()
   if     nLastErr == ERROR_INTERNET_EXTENDED_ERROR
                  //
                  //    Erro retornado por InternetGetLastResponseInfoA()
                  //         Pode ser tambm complementao de ERROR_INTERNET_EXTENDED_ERROR
          nExtErr  := 0
          cMessage := Replicate(Chr(0), INTERNET_MAX_PATH_LENGTH)
          nLen     := 0
          DllExecuteCall(cErrorInternet, @nExtErr, @cMessage, @nLen)
          if nExtErr  <> NO_ERROR
             cMessage := StrTran(Left(cMessage, nLen), Chr(0), '')
             if !Empty(cMessage)
                if Right(cMessage, 2) == CRLF
                   cMessage           := Left(cMessage, (Len(cMessage) - 2))
                endif
                cMessage := ('Internet Extended Error: ' + LTrim(Str(nExtErr)) + ', ' + cMessage)
             endif
          else
             cMessage := ('Internet Extended Error ' + LTrim(Str(nLastErr)) + ' without InternetGetLastReponseInfo() information.')
             if !Empty(nTipError)
                cMessage += (CRLF + '"Tip" error, ' + 'DosErrorMessage(' + LTrim(Str(nTipError)) +'):' + CRLF +;
                                                       DosErrorMessage(nTipError))
             endif
          endif
          exit
   elseif nLastErr ==  ERROR_NOT_CONNECTED
          cMessage := ('Internet Error: could not connect to server')
          exit
   endif
                  //
                  //    Algum erro foi retornado
   cMessage := Replicate(Chr(0), INTERNET_MAX_PATH_LENGTH)
   nLen     := DllExecuteCall(cFormatError, FORMAT_MESSAGE_FROM_SYSTEM,;
                                            NIL,;
                                            nLastErr,;
                                            0,;
                                            @cMessage,;
                                            INTERNET_MAX_PATH_LENGTH,;
                                            NIL)
   if     nLen      > 0
          cMessage := ('Windows message: ' + LTrim(Str(nLastErr)) + ', ' + Left(cMessage, nLen))
          if Right(cMessage, 2) == CRLF
              cMessage          := Left(cMessage, (Len(cMessage) - 2))
          endif
   elseif !Empty(nTipError)
          cMessage := ('ApiGetLastError() indicou erro no documentado: ' + LTrim(Str(nLastErr)) + CRLF+;
                       '"Tip" error ' + LTrim(Str(nTipError)) + ':'                              + CRLF +;
                       DosErrorMessage(nTipError))
   else
          cMessage := ('O erro ' + LTrim(Str(nLastErr)) + ' no conseguiu ser interpretado em ApiGetLastError_()')
   endif
   cMessage += (CRLF + Space(10)    + ProcName(1) + '(' + LTrim(Str(ProcLine(1))) + ')')
   if !Empty(ProcName(2))
      cMessage += (CRLF + Space(10) + ProcName(2) + '(' + LTrim(Str(ProcLine(2))) + ')')
   endif
   exit
enddo
RETURN cMessage